import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Member from '../../api/model/Member';
import MemberService from '../../api/service/MemberService';
import * as SigninActions from '../action/signin';
import SigninPayload from '../payload/SigninPayload';

function* signin(action: Action<SigninPayload>): SagaIterator {
  try {
    const {signinId, signinPw} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const member = yield call(AppContext.getService<MemberService>().signin, signinId, signinPw);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(SigninActions.requestSuccess(member));
  } catch (e) {
    yield put(SigninActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchSignin(): SagaIterator {
  yield takeLatest(SigninActions.REQUEST, signin);
}
