import * as React from 'react';
import { Button, Table, Label, Segment, Header, Container } from 'semantic-ui-react';
import { TargetTable } from './Targets';

export interface Props {
  probe: object;
}

export interface State {
}


export class ProbeDetails extends React.Component<Props, State> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  public componentWillMount(): void {
    super.componentWillMount();
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <ProbeBasicInfo probe={this.props.probe} />
        <TargetTable />
      </Container>
    );
  }
}

export class ProbeBasicInfo extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  public handleStartStop(event: any, data: any): void {
    console.log(event);
  }
  public handleDiscovery(event: any, data: any): void {
    alert('Discovery');
  }

  public handleBack(event: any, data: any): void {
    this.props.onBack();
  }


  public showStartStopBtn(): JSX.Element {
    if (this.props.probe.metaProbeStatus.name === 'STARTED') {
      return <Button content='Stop' icon='stop' labelPosition='left' color={'blue'} floated={'right'} onClick={this.handleStartStop} />;
    } else {
      return <Button content='Start' icon='play' labelPosition='left' color={'blue'} floated={'right'} onClick={this.handleStartStop} />;
    }
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Header as='h3' dividing>Probe Info</Header>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Domain</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.domain.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Status</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.metaProbeStatus.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Host IP</Header>
              </Table.Cell>
              <Table.Cell>????</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Host Name</Header>
              </Table.Cell>
              <Table.Cell>????</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Authorized at</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.createDate}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Description</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.description}</Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>

        <Button content='List' icon='list' labelPosition='left' onClick={this.handleBack.bind(this)} />
        <Button content='Discovery' icon='search' labelPosition='left' floated={'right'} positive onClick={this.handleDiscovery} />
        {this.showStartStopBtn()}

      </Container>
    );
  }
}
