import * as React from 'react';
import { Button, Table, Header, Container } from 'semantic-ui-react';
import { Sensors } from './Sensors';
import { DetailContainer } from './commons/DetailContainer';

export class TargetDetails extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  public handleBack(): void {
    console.log('handleBack');
  }

  public handleRemoveTarget(): void {
    alert('remove');
  }

  public render(): JSX.Element {

    const items = [
      { name: 'Info', child: <TargetBasicInfo probe={this.props.probe} /> },
      { name: 'Sensors', child: <Sensors probe={this.props.probe} /> },
    ];

    return (
      // <DetailContainer panes={items}/>
      <Container fluid>
        <TargetBasicInfo probe={this.props.probe} />
        <Sensors probe={this.props.probe} />
      </Container>
    );
  }
}



export class TargetBasicInfo extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  public handleRemoveTarget(): void {
    alert('remove');
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Header as='h3' dividing>Target Info</Header>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Name</Header>
              </Table.Cell>
              <Table.Cell>
                ???
            </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Type</Header>
              </Table.Cell>
              <Table.Cell>
                ????
            </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Sensor count</Header>
              </Table.Cell>
              <Table.Cell>
                ???
            </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Created at</Header>
              </Table.Cell>
              <Table.Cell>
                ???
            </Table.Cell>
            </Table.Row>

          </Table.Body>
        </Table>
        <Button primary floated={'right'} negative onClick={this.handleRemoveTarget}>Remove</Button>
      </Container>
    );
  }
}
